/* -*- mode: c++; c-basic-offset: 3; -*- */
#include "html/script.hh"
#include "html/genAttr.hh"
#include "html/writer.hh"
#include "html/text.hh"
#include <cstring>
#include <sstream>
#include <iostream>
#include <unistd.h>

using namespace std;
using namespace html;
//====================================== Construct an empty test object
script::script(void) {
}

//======================================  Data constructor
script::script(const std::string& type, const std::string& source) {
   setType(type);
   if (!source.empty()) setSource(source);
}

//======================================  Destroy a script object
script::~script(void) {
}

//======================================  Clone a script object
script* 
script::clone(void) const {
   return new script(*this);
}

//======================================  Install local script copy.
void
script::install(const char* from, const char* to) const {
   if (attributes().exists("src")) {
      string src_file = attributes().find("src").valString();
      // cout << "script: install " << src_file << " from " << from << " to "
      //      << to << endl;
      string target = to;
      if (!target.empty() && target[target.size()-1] != '/') target += "/";
      target += src_file;
      if (!access(target.c_str(), R_OK)) return; //  bail if file extsts.
      string source = from;
      if (!source.empty() && source[source.size()-1] != '/') source += "/";
      source += src_file;
      string cmd = string("/bin/cp -avu ") + source + " " + target;
      int rc = system(cmd.c_str());
      if (rc < 0) {
	 cerr << "html::script: unable to install " << source
	      << " in " << to << endl; 
      }
   }
}

//======================================  Replace the script
void 
script::insertScript(const std::string& txt) {
   addScript(txt);
}

//======================================  Append a script string
void 
script::addScript(const std::string& txt) {
   addObject(text(txt));
}

//======================================  Append a script string
script& 
script::operator<<(const std::string& txt) {
   addScript(txt);
   return *this;
}

//======================================  Set the script color
void
script::setSource(const string& src) {
   attributes().addAttr("src", genAttr(src));
}

//======================================  set the script font
void
script::setType(const string& lang) {
   attributes().addAttr("type", genAttr(lang));
}
